/* The solution which only remembers the first request 
 - the waiting list has length 1
 For remembering all the requests - the waiting list should have
the length N-2 - because the first two players are using the table already
*/

byte waiting_value = 100;
byte table = 0;
byte waiting = waiting_value;


inline wait(val1, val2, p) {
    atomic { val1 == val2 -> val1 = p }    
}

inline play(t, val1, val2, p) {
    atomic {
        t == 0 && val1 != val2 && val1 != p -> t++
    }
}

active [12] proctype user() {
do 
:: if 
     :: wait (waiting, waiting_value, _pid)
     :: play(table, waiting, waiting_value, _pid) -> 
                                    printf("users %d and %d are playing ping-pong\n", _pid, waiting); 
                                    table -- ;
                                    printf("table is free\n"); 
                                    waiting = waiting_value                                                                                     
    fi
od 
}

active proctype verifier1()  {
  assert (table <= 1)
}

